#coding=utf-8
import unittest
from component.CPT_api_request import APIrequest

class DataProviderSupport(type):
    def __new__(meta, classname, bases, classDict):
        # create testdata
        apidata = APIrequest()
        apidata.cpt_createdbconnection()
        # method for creating our test methods
        def create_test_method(testFunc, args):
            return lambda self: testFunc(self, *args)

        # look for data provider functions
        for attrName, attr in classDict.items():
            if attrName.startswith("dataprovider_"):
                # find out the corresponding test method
                testName = attrName[13:]
                testFunc = classDict[testName]
                testtbName = testName[5:]
                # the test method is no longer needed
                del classDict[testName]
                apidata.cpt_getcounts(testtbName)
                # generate test method variants based on
                # data from the data porovider function
                i = 1
                for args in tuple(apidata.counts):
                    classDict[testName + "__"+str(i)] = create_test_method(testFunc, args)
                    i += 1
                
        # create the type
        return type.__new__(meta, classname, bases, classDict)

class Testdriver(unittest.TestCase):
    __metaclass__ = DataProviderSupport
    
    def setUp(self):
        global _apitest
        _apitest = APIrequest()

    def dataprovider_test_dh_item_get_20():
        pass
    def test_dh_item_get_20(self,tbname,rowindex):
        #global_apitest = APIrequest()
        _apitest.cpt_api_getresponse(tbname,rowindex)
        self.assertEqual(_apitest.chck, _apitest.dictdecoderesponsestr, "expect is :\n"+_apitest.chck+ "\n but actual :\n"+_apitest.dictdecoderesponsestr)
    
    def dataprovider_test_dh_item_get_00():
        pass
    def test_dh_item_get_00(self,tbname,rowindex):
        _apitest.cpt_api_getresponse(tbname,rowindex)
        self.assertEqual(_apitest.chck, _apitest.dictdecoderesponsestr, "expect is :\n"+_apitest.chck+ "\n but actual :\n"+_apitest.dictdecoderesponsestr)
    
    def testName(self):
        pass
    
    def dataprovider_test_dh_item_html_get_20():
        pass
    def test_dh_item_html_get_20(self,tbname,rowindex):
        pass

if __name__ == '__main__':
    suite=unittest.TestSuite()   #定义一个单元测试容器
    #print suite
    suite.addTest(Testdriver("testName"))
    suite.addTest(Testdriver("test_dh_item_get_20_1"))
    #suite.addTest(Testdriver("testdh_item_get_20"))
    #suite.addTest(Testdriver("testdh_item_get_00"))
    unittest.TextTestRunner().run(suite)
    #unittest.main()
    